<p>
    Ein Teilbereich von SQL ist die <span class="bold">Data Definition Language (DDL)</span>. Die DDL
    stellt Befehle bereit, um eine Datenbank strukturell zu definieren, also das Schema einer Datenbank
    zu erstellen und zu verändern oder die Datenbank zu löschen.
</p>
<h2>Übersicht und Beispiele zu den Schemaanweisungen</h2>
<p>
    Ähnlich zu der betrachteten Übungsaufgabe im Kapitel Normalisierung sollen auch die folgenden
    Beispiele an das Thema Schülerverwaltung angelehnt sein.
</p>
<div id="accordion" class="ovk-accordion">
    <div class="card">
        <div class="card-header" id="headingOne">
            <h3 class="mb-0">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseOne"
                    aria-expanded="true" aria-controls="collapseOne">
                    CREATE
                </button>
            </h3>
        </div>
    </div>
    <div class="collapse show" id="collapseOne" aria-labelledby="headingOne" data-parent="#accordion">
        <div class="card-body"
            style="border-left: #efefef solid 0.15em; border-right: #efefef solid 0.15em;">
            <div>
                <p>
                    Bevor an die Verwaltung der Schülerdaten mittels Tabellen gedacht werden kann, muss
                    zunächst die Datenbank selbst erstellt werden. Sowohl die Erstellung der Datenbank
                    als auch die Erstellung der Tabellen geschieht mittels <code>CREATE</code>.
                </p>
                <ul class="ovk-list">
                    <li> Eine Datenbank mit der Bezeichnung SchuelerVerwaltung erstellen:
                        <pre class="db-code">
<code class="sql hljs">
CREATE DATABASE SchuelerVerwaltung;
</code>
</pre>
                    </li>
                    <li> Eine Tabelle Schueler soll erstellt werden. Jeder Schüler bekommt dabei die
                        Attribute S_Nr (Primärschlüssel), Nachname, Vorname und Klassenstufe. Für eine
                        ID (in dem Fall S_Nr) typisch wird dafür ein Zahlenwert vergeben. Auch die
                        Klassenstufe wird als Zahlenwert gespeichert und Nachname und Vorname werden als
                        Zeichenketten abgelegt.
                        <pre class="db-code">
<code class="sql hljs">
CREATE TABLE Schueler (
S_Nr INT,
Nachname VARCHAR(20),
Vorname VARCHAR(20),
Klassenstufe INT
);
</code>
</pre>
                    </li>
                </ul>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="card-header" id="headingTwo">
            <h3 class="mb-0">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseTwo"
                    aria-expanded="true" aria-controls="collapseTwo">
                    ALTER
                </button>
            </h3>
        </div>
    </div>
    <div class="collapse" id="collapseTwo" aria-labelledby="headingTwo" data-parent="#accordion">
        <div class="card-body"
            style="border-left: #efefef solid 0.15em; border-right: #efefef solid 0.15em;">
            <div>
                <p>
                    Um an der erstellten Tabelle Schueler Änderungen vornehmen zu können (z.&nbsp;B.
                    eine Spalte Geburtsdatum hinzufügen) wird der Befehl <code>ALTER</code> verwendet.
                </p>
                <ul class="ovk-list">
                    <li> Der Tabelle Schueler soll eine Spalte Geburtsdatum vom Typ Datum hinzugefügt
                        werden:
                        <pre class="db-code">
<code class="sql hljs">
ALTER TABLE Schueler
ADD Geburtsdatum DATE;
</code>
</pre>
                    </li>
                    <li> Im Nachhinein stellt man vielleicht fest, dass auf bestimmte Daten verzichtet
                        werden kann und entfernt die Spalte Geburtsdatum wieder:
                        <pre class="db-code">
<code class="sql hljs">
ALTER TABLE Schueler
DROP COLUMN Geburtsdatum;
</code>
</pre>
                    </li>
                    <li> Die Spalte Klassenstufe soll in die Spalte Klasse umbenannt werden:
                        <pre class="db-code">
<code class="sql hljs">
ALTER TABLE Schueler
RENAME 'Klassenstufe' TO 'Klasse';
</code>
</pre>
                    </li>
                    <li>Mit <code>ALTER COLUMN</code> und <code>TYPE</code> kann der Datentyp einer
                        Spalte verändert werden:
                        <pre class="db-code">
<code class="sql hljs">
ALTER TABLE Schueler
ALTER COLUMN 'Klassenstufe' TYPE VARCHAR(2);
</code>
</pre>
                    </li>
                </ul>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="card-header" id="headingThree">
            <h3 class="mb-0">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseThree"
                    aria-expanded="true" aria-controls="collapseOne">
                    DROP
                </button>
            </h3>
        </div>
    </div>
    <div class="collapse" id="collapseThree" aria-labelledby="headingThree" data-parent="#accordion">
        <div class="card-body"
            style="border-left: #efefef solid 0.15em; border-right: #efefef solid 0.15em; border-bottom: #efefef solid 0.15em">
            <div>
                <p>
                    Statt einer einzelnen Spalte lässt sich der Befehl <code>DROP</code> auch auf eine
                    Tabelle anwenden.
                </p>
                <ul class="ovk-list">
                    <li> Die Tabelle Schueler soll gelöscht werden:
                        <pre class="db-code">
<code class="sql hljs">
DROP TABLE Schueler;
</code>
</pre>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</div>
<h2>Übung</h2>
<p>
    {{> aufgabe }} Füge der Tabelle Person der Datenbank, die im {{> sqlfiddle }} definiert ist, eine
    weitere Spalte Geburtsdatum hinzu. Welche Werte werden für die existierenden Tupel der Tabelle als
    Geburtsdatum hinterlegt?
</p>
